<?php
// $Id: weblinks_link_form_admin_handler.php,v 1.4 2006/10/14 13:45:12 ohwada Exp $

// 2006-10-14 K.OHWADA
// use _AM_WEBLINKS_ADD_BANNER

// 2006-10-05 K.OHWADA
// this is new file
// use rssc WEBLINKS_RSSC_USE
// divid from weblinks_link_form_handler
// google map

//=========================================================
// WebLinks Module
// 2006-10-05 K.OHWADA
//=========================================================

// === class begin ===
if( !class_exists('weblinks_link_form_admin_handler') ) 
{

//=========================================================
// class weblinks_link_form_admin_handler
//=========================================================
class weblinks_link_form_admin_handler extends weblinks_link_form_handler
{
	var $_saved_obj = null;

//---------------------------------------------------------
// constructor
//---------------------------------------------------------
function weblinks_link_form_admin_handler( $dirname )
{
	$this->weblinks_link_form_handler( $dirname );
}

//---------------------------------------------------------
// init
//---------------------------------------------------------
function begin_admin_form()
{
	$this->clear_local();
	$this->set_flag_owner( true );
	$this->_flag_admin_caption = true;
	$this->_flag_url_visit = 1;
	$this->_mode_banner_size = 0;

	$this->_conf_desc_option = array(
		'dohtml'   => true,
		'dosmiley' => true,
		'doxcode'  => true,
		'doimage'  => true,
		'dobr'     => true,
	);
}

//---------------------------------------------------------
// show_admin_form
//---------------------------------------------------------
function show_admin_form($form_mode, $id=0)
{
	$this->_form_mode = $form_mode;
	$this->_id        = $id;

	$this->init();
	$this->begin_admin_form();

	$linkitem_arr = $this->_load_define();

	$lid = 0;
	$mid = 0;
	$desc_disp   = '';
	$flag_label  = false;
	$flag_broken = false;

// password
	$passwd_new = $this->_post->get_post_text('passwd_new');
	$passwd_2   = $this->_post->get_post_text('passwd_2');

	switch ($form_mode)
	{
		case 'modify':
		case 'modify_preview':
			$form_title   = _WLS_MODLINK;
			$submit_value = _WLS_MODIFY;
			$op           = 'modLinkS';
			$button_name  = 'delete_link';
			$button_value = _DELETE;
			$flag_broken  = true;
			$flag_label   = true;
			break;

		case 'approve':
		case 'approve_preview':
			$form_title   = _WLS_MODREQUESTS;
			$submit_value = _WLS_APPROVE;
			$op           = 'approve';
			$button_name  = 'delete_new';
			$button_value = _WLS_IGNORE;
			break;

		case 'submit':
		case 'submit_preview':
		default:
			$form_title   = _WLS_ADDNEWLINK;
			$submit_value = _WLS_ADD;
			$op           = 'addLinkS';
			$button_name  = '';
			$button_value = '';
			break;
	}

	switch ($form_mode)
	{
		case 'modify':
			$lid = intval($id);
			$edit_obj =& $this->get_edit( $lid );
			if ( !is_object($edit_obj) )
			{
				echo "no link record lid=$lid <br />\n";
				return false;
			}
			$edit_obj->build_admin_modify($lid);
			break;

		case 'approve':
			$mid = intval($id);
			$edit_obj =& $this->get_edit_modify( $mid );
			if ( !is_object($edit_obj) )
			{
				echo "no modify record mid=$mid <br />\n";
				return false;
			}
			$edit_obj->build_admin_approve();
			break;

		case 'submit_preview':
			$edit_obj =& $this->create_edit();
			$edit_obj->build_admin_submit_preview();
			break;

		case 'modify_preview':
			$lid = $this->_post->get_post_int('lid');
			$edit_obj =& $this->get_edit( $lid );
			if ( !is_object($edit_obj) )
			{
				echo "no link record lid=$lid <br />\n";
				return false;
			}
			$edit_obj->build_admin_modify_preview();
			break;

		case 'approve_preview':
			$mid = $this->_post->get_post_int('mid');
			$edit_obj =& $this->get_edit_modify( $mid );
			if ( !is_object($edit_obj) )
			{
				echo "no modify record mid=$mid <br />\n";
				return false;
			}
			$edit_obj->build_admin_approve_preview();
			break;

		case 'submit':
		default:
			$edit_obj =& $this->create_edit();
			$edit_obj->build_admin_submit();
			break;
	}

	$edit_obj->set('lid', $lid);
	$edit_obj->get('mid', $mid);

	$this->set_obj( $edit_obj );

	switch ($form_mode)
	{
		case 'modify':
		case 'approve':
			$cid_arr = $this->get_obj_var('cid_arr');
			if ( !is_array($cid_arr) || !count($cid_arr) )
			{
				xoops_error("No Category");
				echo "<br />\n";
			}
			break;
	}

	switch ($form_mode)
	{
		case 'modify':
		case 'modify_preview':
			$url   = '../singlelink.php?lid='.$lid;
			$title = $this->get_obj_var('title');
			echo '<a href="'.$url.'">'._WEBLINKS_GOTO_SINGLELINK.': '.$title."</a><br /><br />\n";
			break;
	}

	foreach ($linkitem_arr as $id => $linkitem )
	{
		$form  = $linkitem['admin_form'];

		switch ($form)
		{
			case 'hidden':
				$this->add_hidden_by_id($id);
				break;

			case 'label':
				if ( $flag_label )
				{
					$this->add_label_by_id($id);
				}
				break;

			case 'label_float':
				if ( $flag_label )
				{
					$this->add_label_float_by_id($id);
				}
				break;

			case 'text':
				$this->add_text_by_id($id);
				break;

			case 'textarea':
			case 'admincomment':
				$this->add_textarea_by_id($id);
				break;

			case 'url':
				$this->add_url_by_id($id);
				break;

			case 'radio':
				$this->add_radio_by_id($id);
				break;

			case 'checkbox':
				$this->add_checkbox_by_id($id);
				break;

			case 'yesno':
				$this->add_yesno_by_id($id);
				break;

			case 'mid':
				$this->add_admin_id($id);
				break;

			case 'lid':
				$this->add_admin_id($id);
				break;

			case 'uid':
				$this->add_admin_uid($id);
				break;

			case 'time_create':
				$this->add_admin_time_create($id);
				break;

			case 'time_update':
				$this->add_admin_time_update($id);
				break;

			case 'cat':
				$this->add_cat_by_id($id);
				break;

			case 'desc':
				$this->add_desc_by_id($id);
				break;

			case 'broken':
				if ($flag_broken)
				{
					$this->add_admin_broken($id);
				}
				break;

			case 'banner':
				$this->add_admin_banner($id);
				break;

			case 'banner_size':
				$this->add_admin_banner_size($id);
				break;

			case 'rss_url':
				$this->add_rss_url_by_id($id);
				break;

			case 'name':
				$this->add_name_by_id($id);
				break;

			case 'mail':
				$this->add_mail_by_id($id);
				break;

			case 'passwd':
				$this->add_admin_passwd($id);
				break;

// rssc
			case 'rssc_lid':
				if ( WEBLINKS_RSSC_USE )
				{
					$this->add_admin_rssc_lid($id);
				}
				break;

// google map
			case 'gm_latitude':
				$this->add_gm_latitude_by_id($id);
				break;

			case 'notify':
			case 'none':
			default:
				break;
		}
	}

// print form
	$this->print_form($form_title, $op, $submit_value, $button_name, $button_value );
	return true;
}

//---------------------------------------------------------
// show_admin_mod_approve_form
//---------------------------------------------------------
function show_admin_mod_approve_form($form_mode, $mid=0)
{
	$this->_form_mode = $form_mode;
	$this->_mid       = $mid;

	$this->init();
	$this->begin_admin_form();

	$linkitem_arr = $this->_load_define();

	$form_title   = _WLS_MODREQUESTS;
	$submit_value = _WLS_APPROVE;
	$op           = 'approveModReq';
	$button_name  = 'ignore';
	$button_value = _WLS_IGNORE;

	switch ($form_mode)
	{
		case 'preview':
			$edit_obj =& $this->get_edit_modify( $mid );
			if ( !is_object($edit_obj) )
			{
				echo "no modify record mid=$mid <br />\n";
				return false;
			}
			$edit_obj->build_admin_approve_modify_preview();
			break;

		case 'approve':
		default:
			$edit_obj =& $this->get_edit_modify( $mid );
			if ( !is_object($edit_obj) )
			{
				echo "no modify record mid=$mid <br />\n";
				return false;
			}
			$edit_obj->build_admin_approve_modify();
			break;
	}

	$edit_obj->get('mid', $mid);

	$this->set_obj( $edit_obj );

	$lid = $edit_obj->get('lid');
	$saved_obj =& $this->get_edit( $lid );
	if ( !is_object($saved_obj) )
	{
		echo "no link record lid=$lid <br />\n";
		return false;
	}

	$saved_obj->build_admin_modify( $lid );
	$this->set_saved_obj( $saved_obj );

	foreach ($linkitem_arr as $id => $linkitem )
	{
		$form  = $linkitem['admin_form'];

		switch ($form)
		{
			case 'hidden':
				$this->add_hidden_by_id($id);
				break;

			case 'text':
				$this->add_text_by_id($id);
				$this->add_admin_text_saved($id);
				break;

			case 'textarea':
				$this->add_textarea_by_id($id);
				$this->add_admin_textarea_saved($id);
				break;

			case 'checkbox':
				$this->add_checkbox_by_id($id);
				$this->add_admin_checkbox_saved($id);
				break;

			case 'yesno':
				$this->add_yesno_by_id($id);
				$this->add_admin_yesno_saved($id);
				break;

			case 'url':
				$this->add_url_by_id($id);
				$this->add_admin_url_saved($id);
				break;

			case 'mid':
				$this->add_admin_id($id);
				break;

			case 'lid':
				$this->add_admin_id($id);
				break;

			case 'uid':
				$this->add_admin_uid($id);
				$this->add_admin_uid_saved($id);
				break;

			case 'time_create':
				$this->add_admin_time_create($id);
				break;

			case 'time_update':
				$this->add_admin_time_update($id);
				break;

			case 'cat':
				$this->add_cat_by_id($id);
				$this->add_admin_cat_saved($id);
				break;

			case 'desc':
				$this->add_desc_by_id($id);
				$this->add_admin_textarea_saved($id);
				break;

			case 'admincomment':
				$this->add_admin_admincomment_saved($id);
				break;

			case 'banner':
				$this->add_admin_banner($id);
				$this->add_admin_banner_saved($id);
				break;

			case 'rss_url':
				$this->add_rss_url_by_id($id);
				$this->add_admin_rss_url_saved($id);
				break;

			case 'name':
				$this->add_name_by_id($id);
				$this->add_admin_name_saved($id);
				break;

			case 'mail':
				$this->add_mail_by_id($id);
				$this->add_admin_mail_saved($id);
				break;

			case 'passwd':
				$this->add_admin_approve_passwd($id);
				break;

// google map
			case 'gm_latitude':
				$this->add_gm_latitude_by_id($id);
				$this->add_admin_text_saved($id);
				break;

			case 'notify':
			case 'none':
			default:
				break;
		}
	}

// print form
	$this->print_form($form_title, $op, $submit_value, $button_name, $button_value );
	return true;
}

//---------------------------------------------------------
// get cache
//---------------------------------------------------------
function set_saved_obj(&$obj)
{
	$this->_saved_obj = $obj;
}

function get_saved_obj_var($key, $format='s')
{
	$val = $this->_saved_obj->getVar($key, $format);
	return $val;
}

//---------------------------------------------------------
// link item
//---------------------------------------------------------
function add_admin_id($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	if ($value > 0)
	{
		$id_s = "<b>".$value."</b>";
		$this->add_label_by_id($id);
		$this->add_hidden_by_id($id);
	}
}

function add_admin_uid($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$this->add_text_by_id($id);

	$link_uname = $this->build_user_link_uname_by_uid( $value );
	$link_email = $this->build_user_link_email_by_uid( $value );
	$value2 = $link_uname."&nbsp;&nbsp;".$link_email;
	$cap2  =  $this->_build_caption( _WLS_SUBMITTER );
	$text2 = $this->_build_value_when_empty( $value2 );
	$this->add_buff($cap2, $text2);
}

function add_admin_time_create($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$text = '---';
	if ($value)
	{
		$text = formatTimestamp($value, 'l');
	}
	$this->add_buff( $cap, $text );
}

function add_admin_time_update($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$text = '---';
	if ($value)
	{
		$updateflag = $this->get_obj_var('updateflag');
		$text  = formatTimestamp($value, 'l');
		$text .= "<br />\n";
		$text .= $this->build_html_input_radio_select('updateflag', $updateflag, $opt);
	}
	$this->add_buff( $cap, $text );
}

function add_admin_broken($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$text = $this->build_html_input_text($name, $value, $this->TEXT_SIZE, $this->TEXT_MAX);

	$lid = $this->get_obj_var('lid');
	$broken_count = $this->_broken_handler->get_count_by_lid($lid);
	if ( $broken_count )
	{
		$text .= "<br />\n";
		$text .= $this->build_html_highlight(' Broken Report');
	}

	$this->add_buff( $cap, $text );
}

function add_admin_banner($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$width  = $this->get_obj_var('width');
	$height = $this->get_obj_var('height');
	$text   = $this->build_edit_url_with_visit($name, $value);

	if ($value)
	{
		$text .= "<br />\n";
		$text .= $this->build_html_img_tag($value, $width, $height, 0, 'banner');
	}

	$this->add_buff( $cap, $text );
}

function add_admin_banner_size($id)
{
	if ( $this->_mode_banner_size )
	{
		$this->add_text_by_id($id);
	}
	else
	{
		$this->add_label_by_id($id);
	}
}

function add_admin_passwd($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);
	$passwd_new = $this->get_obj_var( 'passwd_new' );
	$passwd_old = $this->get_obj_var( 'passwd_old' );
	$passwd_2   = $this->get_obj_var( 'passwd_2' );

	$name3 = 'passwd_md5';
	$cap2  = $this->_build_caption_by_itemid($id, _US_TYPEPASSTWICE );

	switch ($this->_form_mode)
	{
		case 'modify':
			$this->add_passwd_new( $cap2, '', '' );
			break;

		case 'modify_preview':
			$this->add_passwd_new( $cap2, $passwd_new, $passwd_2 );
			break;

		case 'approve':
		case 'approve_preview':
			$this->add_hidden( $name3, $value );
			break;

		case 'submit':
		case 'submit_preview':
		default:
			$this->add_passwd_new( $cap, $passwd_new, $passwd_2 );
			break;
	}
}

function add_admin_approve_passwd($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	$name3 = 'passwd_md5';
	$this->add_hidden($name3, $value);
}

function add_admin_rssc_lid($id)
{
	list( $cap, $name, $value, $opt, $admin_form, $mode ) = $this->get_admin_param($id);

	switch ($this->_form_mode)
	{
		case 'modify':
		case 'modify_preview':
		case 'approve':
		case 'approve_preview':
			$cap1  = $this->_build_caption( _RSSC_RSSC_LID );
			$text1 = $this->build_html_input_text($name, $value, $this->TEXT_SIZE, $this->TEXT_MAX);
			if ( $value )
			{
				$url = WEBLINKS_RSSC_URL.'/admin/link_manage.php?op=mod_form&lid='.$value;
				$name2 = _RSSC_GOTO_RSSC_ADMIN_LINK;
				$text1 .= '<br />'.$this->build_html_a_href_name($url, $name2);
			}
			$this->add_buff( $cap1, $text1 );

			$cap2  = $this->_build_caption( _RSSC_RSSC_LID_UPDATE );
			$text2 = $this->build_form_radio_yesno('rssc_lid_update', $this->get_obj_var('rssc_lid_update') );
			$this->add_buff( $cap2, $text2 );
			break;

		case 'submit':
		case 'submit_preview':
		default:
			break;
	}
}

//---------------------------------------------------------
// admin original item
//---------------------------------------------------------
function add_admin_text_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);
	$text = $this->_build_value_when_empty( $saved_value );
	$this->add_buff( '', $text );
}

function add_admin_uid_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$link_uname = $this->build_user_link_uname_by_uid($saved_value);
	$link_email = $this->build_user_link_email_by_uid($saved_value);
	$value = $saved_value ."&nbsp;&nbsp;". $link_uname ."&nbsp;&nbsp;". $link_email;
	$cap   =  $this->_build_caption( _WLS_OWNER );

	$this->add_label($cap, $value);
}

function add_admin_checkbox_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$text = $this->_build_value_checked( $saved_value, $opt );
	$this->add_buff( '', $text );
}

function add_admin_yesno_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$opt_yesno =& $this->get_form_radio_yesno_options();
	$text = $this->_build_value_checked( $saved_value, $opt_yesno );
	$this->add_buff( '', $text );
}

function add_admin_url_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$text  = $saved_value;
	$text .= $this->build_edit_visit($saved_value);

	$this->add_buff( '', $text );
}

function add_admin_banner_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$width  = $this->get_saved_obj_var('width');
	$height = $this->get_saved_obj_var('height');

	if ($saved_value)
	{
		$text  = $saved_value;
		$text .= $this->build_edit_visit($saved_value);
		$text .= "<br />\n";
		$text .= $this->build_html_img_tag($saved_value, $width, $height, 0, 'banner');
	}
	else
	{
		$text = '---';
	}

	$this->add_buff( '', $text );
}

function add_admin_rss_url_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$name2  = 'rss_flag';
	$value2 = $this->get_obj_var($name2);
	$opt2   = $this->_get_options_by_name($name2);

	if ($saved_value)
	{
		$text  = $saved_value;
		$text .= $this->build_edit_visit($saved_value);
	}
	else
	{
		$text = '---';
	}

	$text .= "<br />\n";
	$text .= $this->_build_value_checked( $value2, $opt2 );
	$this->add_buff( '', $text );
}

function add_admin_name_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$this->add_admin_name_mail_saved($saved_value, 'nameflag');
}

function add_admin_mail_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$this->add_admin_name_mail_saved($saved_value, 'mailflag');
}

function add_admin_name_mail_saved($value1, $name2)
{
	$value2 = $this->get_obj_var($name2);
	$opt2   = $this->_get_options_by_name($name2);

	$text   = $this->_build_value_when_empty($value1)."<br />";
	$text  .= $this->_build_value_checked($value2, $opt2);
	$this->add_buff( '', $text );
}

function add_admin_textarea_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	if ( $saved_value == '')
	{
		$text = '---';
	}
	else
	{
		$text = $this->_build_show_textarea($saved_value, 1);
	}

	$this->add_buff( '', $text );
}

function add_admin_admincomment_saved($id)
{
	list( $cap, $name, $saved_value, $opt, $admin_form, $mode ) = $this->get_saved_param($id);

	$text  = _WEBLINKS_ADMIN_PRESENT_SAVE."<br />\n";
	$text .= $this->build_html_textarea($name, $saved_value, $this->TEXTAREA_ROW, $this->TEXTAREA_COL);
	$this->add_buff( $cap, $text );
}

function add_admin_cat_saved($id)
{
	$cid_arr = $this->get_saved_obj_var('cid_arr');

	$catpath= '';
	foreach ($cid_arr as $cid)
	{
		$catpath .= $this->_category_handler->build_cat_path($cid, 's');
		$catpath .= "<br />\n";
	}

	$this->add_buff( '', $catpath );
}

//---------------------------------------------------------
// admin image
//---------------------------------------------------------
function show_admin_banner_form( $lid, $width, $height, $op_mode )
{

	switch ($op_mode)
	{
		case 'mod_banner':
		case 'mod_banner_preview':
			$form_title = _AM_WEBLINKS_MOD_BANNER;
			$op         = 'mod_banner';
			$url_cancel = 'link_list.php';
			break;

		case 'add_banner':
		case 'add_banner_preview':
		default:
			$form_title = _AM_WEBLINKS_ADD_BANNER;
			$op         = 'add_banner';
			$url_cancel = 'link_list.php?sortid=1';
			break;
	}

	$obj =& $this->create_edit();
	$obj->build_admin_submit_preview();

	$this->set_obj( $obj );

	$banner = $obj->get('banner');

// --- form start---
	echo $this->build_form_begin( 'add_image' );
	echo $this->build_token();
	echo $this->build_html_input_hidden('op',       $op );
	echo $this->build_html_input_hidden('op_mode',  $op_mode );
	echo $this->build_html_input_hidden('lid',      $lid );
	echo $this->build_html_input_hidden('title',    $this->sanitize_text( $obj->get('title') ) );
	echo $this->build_html_input_hidden('url',      $this->sanitize_url(  $obj->get('url') ) );
	echo $this->build_html_input_hidden('rss_url',  $this->sanitize_url(  $obj->get('rss_url') ) );
	echo $this->build_html_input_hidden('rss_flag', $this->sanitize_url(  $obj->get('rss_flag') ) );

	echo $this->build_form_table_begin();
	echo $this->build_form_table_title( $form_title );

	echo $this->build_form_table_line(_WLS_LINKID, $lid);
	echo $this->build_obj_table_label(_WLS_SITETITLE, 'title');

	$ele_banner = $this->build_edit_url_with_visit( 'banner', $banner );

	if ($banner)
	{
		$ele_banner .= "<br /><br />\n";
		$ele_banner .= $this->build_html_img_tag($banner, $width, $height, 0, 'banner');
	}

	echo $this->build_form_table_line(_WLS_BANNERURL, $ele_banner);

	echo $this->build_form_table_text('width',  'width',  $width);
	echo $this->build_form_table_text('height', 'height', $height);

	$ele_submit   = $this->build_html_input_submit('submit', _EXECUTE);
	$ele_cancel   = $this->build_html_input_button_location('cancel', _CANCEL, $url_cancel);
	$ele_button   = $ele_submit.' '.$ele_cancel;
	echo $this->build_form_table_line('', $ele_button, 'foot', 'foot');

	echo $this->build_form_table_end();
	echo $this->build_form_end();
// --- form end ---

}

// --- class end ---
}

// === class end ===
}

?>